# coding: utf-8

"""
    trivium-cash

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.2.8
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from trivium_python_sdk.models.cash_account_activated import CashAccountActivated
from trivium_python_sdk.models.deposit_settled import DepositSettled
from trivium_python_sdk.models.redemption_reconciled import RedemptionReconciled
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

CASHCALLBACKEVENT_ONE_OF_SCHEMAS = ["CashAccountActivated", "DepositSettled", "RedemptionReconciled"]

class CashCallbackEvent(BaseModel):
    """
    CashCallbackEvent
    """
    # data type: CashAccountActivated
    oneof_schema_1_validator: Optional[CashAccountActivated] = None
    # data type: DepositSettled
    oneof_schema_2_validator: Optional[DepositSettled] = None
    # data type: RedemptionReconciled
    oneof_schema_3_validator: Optional[RedemptionReconciled] = None
    actual_instance: Optional[Union[CashAccountActivated, DepositSettled, RedemptionReconciled]] = None
    one_of_schemas: Set[str] = { "CashAccountActivated", "DepositSettled", "RedemptionReconciled" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = CashCallbackEvent.model_construct()
        error_messages = []
        match = 0
        # validate data type: CashAccountActivated
        if not isinstance(v, CashAccountActivated):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CashAccountActivated`")
        else:
            match += 1
        # validate data type: DepositSettled
        if not isinstance(v, DepositSettled):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DepositSettled`")
        else:
            match += 1
        # validate data type: RedemptionReconciled
        if not isinstance(v, RedemptionReconciled):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RedemptionReconciled`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in CashCallbackEvent with oneOf schemas: CashAccountActivated, DepositSettled, RedemptionReconciled. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in CashCallbackEvent with oneOf schemas: CashAccountActivated, DepositSettled, RedemptionReconciled. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into CashAccountActivated
        try:
            instance.actual_instance = CashAccountActivated.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DepositSettled
        try:
            instance.actual_instance = DepositSettled.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RedemptionReconciled
        try:
            instance.actual_instance = RedemptionReconciled.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into CashCallbackEvent with oneOf schemas: CashAccountActivated, DepositSettled, RedemptionReconciled. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into CashCallbackEvent with oneOf schemas: CashAccountActivated, DepositSettled, RedemptionReconciled. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], CashAccountActivated, DepositSettled, RedemptionReconciled]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


