# coding: utf-8

"""
    trivium-cash

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.2.8
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from trivium_python_sdk.models.locked_fixed_deposit import LockedFixedDeposit
from trivium_python_sdk.models.pending_fixed_deposit import PendingFixedDeposit
from trivium_python_sdk.models.processing_fixed_deposit import ProcessingFixedDeposit
from trivium_python_sdk.models.redeemed_fixed_deposit import RedeemedFixedDeposit
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

FIXEDDEPOSITPLACEMENT_ONE_OF_SCHEMAS = ["LockedFixedDeposit", "PendingFixedDeposit", "ProcessingFixedDeposit", "RedeemedFixedDeposit"]

class FixedDepositPlacement(BaseModel):
    """
    FixedDepositPlacement
    """
    # data type: LockedFixedDeposit
    oneof_schema_1_validator: Optional[LockedFixedDeposit] = None
    # data type: PendingFixedDeposit
    oneof_schema_2_validator: Optional[PendingFixedDeposit] = None
    # data type: ProcessingFixedDeposit
    oneof_schema_3_validator: Optional[ProcessingFixedDeposit] = None
    # data type: RedeemedFixedDeposit
    oneof_schema_4_validator: Optional[RedeemedFixedDeposit] = None
    actual_instance: Optional[Union[LockedFixedDeposit, PendingFixedDeposit, ProcessingFixedDeposit, RedeemedFixedDeposit]] = None
    one_of_schemas: Set[str] = { "LockedFixedDeposit", "PendingFixedDeposit", "ProcessingFixedDeposit", "RedeemedFixedDeposit" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = FixedDepositPlacement.model_construct()
        error_messages = []
        match = 0
        # validate data type: LockedFixedDeposit
        if not isinstance(v, LockedFixedDeposit):
            error_messages.append(f"Error! Input type `{type(v)}` is not `LockedFixedDeposit`")
        else:
            match += 1
        # validate data type: PendingFixedDeposit
        if not isinstance(v, PendingFixedDeposit):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PendingFixedDeposit`")
        else:
            match += 1
        # validate data type: ProcessingFixedDeposit
        if not isinstance(v, ProcessingFixedDeposit):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ProcessingFixedDeposit`")
        else:
            match += 1
        # validate data type: RedeemedFixedDeposit
        if not isinstance(v, RedeemedFixedDeposit):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RedeemedFixedDeposit`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in FixedDepositPlacement with oneOf schemas: LockedFixedDeposit, PendingFixedDeposit, ProcessingFixedDeposit, RedeemedFixedDeposit. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in FixedDepositPlacement with oneOf schemas: LockedFixedDeposit, PendingFixedDeposit, ProcessingFixedDeposit, RedeemedFixedDeposit. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into LockedFixedDeposit
        try:
            instance.actual_instance = LockedFixedDeposit.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PendingFixedDeposit
        try:
            instance.actual_instance = PendingFixedDeposit.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ProcessingFixedDeposit
        try:
            instance.actual_instance = ProcessingFixedDeposit.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RedeemedFixedDeposit
        try:
            instance.actual_instance = RedeemedFixedDeposit.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into FixedDepositPlacement with oneOf schemas: LockedFixedDeposit, PendingFixedDeposit, ProcessingFixedDeposit, RedeemedFixedDeposit. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into FixedDepositPlacement with oneOf schemas: LockedFixedDeposit, PendingFixedDeposit, ProcessingFixedDeposit, RedeemedFixedDeposit. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], LockedFixedDeposit, PendingFixedDeposit, ProcessingFixedDeposit, RedeemedFixedDeposit]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


